;9/3/02 - added #ifndef statements and such
;7/29/02 removed detection code, now acts as a catch-all for
;  programs that didn't fit with other datatypes

;basic datatype for YAS 2.0
;by Jonah Cohen (all the cool parts) and Aaron Curtis

#define bashighc(x) $f400+x-bas_comment
#define bashighi(x) $f400+x-bas_icon
#define bashighd(x) $f400+x-bas_detect
#define basrelptr(x) x-$-1			;relative pointer

	.db 0
	.db $12
	.db "bas"

	.dw bas_exec

	.dw bas_enddetect-bas_detect
	.dw basrelptr(bas_detect)

	.dw bas_endcomment-bas_comment
	.dw basrelptr(bas_comment)

	.dw bas_endicon-bas_icon
	.dw basrelptr(bas_icon)

bas_detect:
	or a
	ret
bas_enddetect:

bas_exec:

	;*** code added to make this thing work on it's own
	;*** can be removed if an inter(r?)upt is installed in the shell

    ld hl,$f500
    ld a,h
    ld i,a                  ;i=$f0, signals that $f500 begins the vector table
install_int:
    ld (hl),$f6             ;loop to fill the next 256 bytes with $f6
    inc l
    jr nz,install_int		;at the end, hl=$f500 again
    inc h                   ;so make hl $f600
    ld (hl),h               ;and put $f6 in the 257th byte as well (vector table complete)

	;*** end of added code

	rst 10h
    call _DATA_SIZE_TO_DE
    call _GET_DATA_SIZE_DE_INC
    ld a,e
    or a
    jr nz,tokenized
    cp d
    push af                     ;z=locked

    call _clrWindow
    ld hl,$0403
    ld (_curRow),hl
    ld hl,tokenizing
    call _puts                  ;display message while tokenizing

    ld hl,token_int_start
    ld de,$f6f6
    ld c,token_int_end-token_int_start
    ldir
    im 2                        ;"Tokenizing..."

    rst 18h                     ;push varname onto stack
    call _setupEditequ
    call _bufToTop
    pop af
    push af
    call z,_bufDelete           ;unlock if it's locked
    call _tokenize              ;tokenize it
    call _bufToTop
    pop af
    push af
    call nz,_bufDelete          ;unlock
    pop af
    call nz,_bufDelete
    call _closeEditequ
    call _POPOP1                ;retrieve varname

    im 1
tokenized:
    call _clrWindow
    res 4,(iy+9)                ;no error break
    call _PARSEINP              ;run basic prog
    in a,(5)
    cp $0d                      ;if not on page $0d, we hit the STOP command
    ld a,$0d
    out (5),a
    jp nz,_JforceCmdNoChar
    ret

tokenizing: .db "Tokenizing...  ",0

token_int_start:
    ex af,af'
    exx
    in a,(3)
    and %00000001
    add a,9
    out (3),a
    ld a,11
    out (3),a
    in a,(5)
    push af
    ld a,$0d
    out (5),a
#if 0
    ld hl,$1103
    ld (_curRow),hl
    ld de,(_P_BEGPC+1)          ;bde=beginning value
    ld hl,(_P_ENDPC+1)
    sbc hl,de
    ld a,l
    ld hl,(_P_CURPC+1)
    or a
    sbc hl,de
    srl h
    rr l
    ld h,l
    ld l,0
    call _divHLbyA
    xor a
    call _dispHL
#endif
    ld a,-1
token_counter = $-1-token_int_start+$f6f6
    inc a
    and %00111111
    ld (token_counter),a
    jr nz,leave_token_int
    ld hl,$0f03
    ld (_curRow),hl
    ld hl,tokenizing+13
dot_column = $-2-token_int_start+$f6f6
    call _puts
    ld hl,dot_column
    dec (hl)
    ld a,(hl)
    cp (tokenizing+10)&$ff
    jr nz,leave_token_int
    ld (hl),(tokenizing+13)&$ff
leave_token_int:
    pop af
    out (5),a
    exx
    ex af,af'
    ei
    ret
token_int_end:


bas_comment:
#ifdef NOCOMMENT
	scf
	ret
#else
    ld a,(hl)
    or a
    jr z,ubasic                 ;uncompiled basic (a pain)
    cp $8e                      
    jr nz,no8e                  ;$8e is the first byte of a 2 byte token, could be edit locking
    inc hl
    ld a,(hl)
    cp $29                      ;$8e29 is edit locking
    inc hl
    jr z,bas_comment            ;if edit locked, go to the next token and check again ($8e00 is not a token)
no8e:
    cp $6e                      ;token for a colon ($8e6e is not a token) (I think)
    scf
    ret nz
    inc hl
    ld a,(hl)
    cp $2d                      ;token for a string
    scf
    ret nz
    inc hl
    or a
    ret
ubasic:
    inc hl
    ld a,(hl)
    cp $3a
    scf
    ret nz
    inc hl
    ld a,(hl)
    cp $22
    scf
    ret nz
    inc hl
    ld de,$f400
    push de
ubasicloop:
    ldi
    ld a,(hl)
    sub $22
    jr nz,ubasicloop
    ld (de),a
    pop hl
    ret
#endif
bas_endcomment:

bas_icon:
#ifdef NOICON
	scf
	ret
#else
#ifdef BAS_NODEFAULTICON
	scf
	ret
#else
    ld hl,bashighi(bas_default_icon+2)
	ld bc,7+(256*1)
	or a
    ret

bas_default_icon:
.db 7,1
.db %00010000
.db %10111010
.db %01000100
.db %01000100
.db %01000100
.db %00111000
.db %01000100

#endif
#endif
bas_endicon:

.end
